from capytale.autoeval import ValidateVariables, ValidateFunctionPretty, Validate
import math
depart = Validate()
_graphe = {
    "A": {"B": 85, "E": 173, "C": 217},
    "B": {"F": 80},
    "C": {"H": 103, "G": 186},
    "D": {},
    "E": {"J": 502},
    "F": {"I": 250},
    "G": {},
    "H": {"J":167, "D": 183},
    "I": {"J": 84},
    "J": {}
}
def _voisins_de(graphe, s):
    return list(graphe[s].keys())

def _sommets_de(graphe):
    return list(graphe.keys())

def _choix_suivant(distances, vus):
    mini = math.inf
    a = None
    for s, d in distances.items():
        if s not in vus and d < mini:
            mini = d
            a = s
    return a

def _dijsktra(graphe, s):
    # Initialisation
    vus = []
    distances = {}
    predecesseurs = {}
    
    # Création du tableau des distances
    sommets = _sommets_de(graphe)
    for sm in sommets:
        distances[sm] = math.inf
    distances[s] = 0
    
    while len(vus) != len(sommets):
        # Choisir un sommet a hors de P de plus petite distance d[a]
        a = _choix_suivant(distances, vus)
        vus.append(a)
        for v in _voisins_de(graphe, a):
            if v in vus:
                continue
            distances[v] = distances[a] + graphe[a][v]
            predecesseurs[v] = a
    return distances, predecesseurs



test_graphe = ValidateVariables({"graphe": _graphe})
test_voisins_de = ValidateFunctionPretty("voisins_de", ((_graphe, "A"), (_graphe, "B"), (_graphe, "C")),
                                        valid_function=_voisins_de, check_signature=True)

test_sommets_de = ValidateFunctionPretty("sommets_de", [_graphe],
                                          valid_function=_sommets_de, check_signature=True)

test_choix_suivant = ValidateFunctionPretty("choix_suivant", [
    [{"A": 12, "B": 88, "C": 44, "D": 22}, ["A", "C"]],
    [{"A": 12, "B": 88, "C": 44, "D": 22}, ["A", "B", "C", "D"]],
    [{"A": -12, "B": -88, "C": -44, "D": -22}, ["A", "C"]],
],valid_function=_choix_suivant, check_signature=True)

test_dijsktra = ValidateFunctionPretty("dijsktra", [(_graphe, "A")],
                                    valid_function=_dijsktra, check_signature=True)