from capytale.autoeval import (
    ValidateVariables,
    ValidateFunction,
    ValidateFunctionPretty,
)


test_exo_1 = ValidateVariables({"caractere": "😭", "decimal": ord("😭"),
                                "binaire": bin(ord("😭")), "hexadecimal": hex(ord("😭")),
                               "octets": "😭".encode("UTF-8")})
def _exo2(c):
    return str(bin(ord(c)))[2:]

test_exo_2 = ValidateFunctionPretty(
    "bits_unicode", ["a", "€","Σ", "😭", "😛"],
    valid_function=_exo2, check_signature=True)


def _exo31(c):
    return len(_exo2(c))

test_exo_3_1 = ValidateFunctionPretty(
    "taille_bits_unicode", ["a", "€","Σ", "😭", "😛"],
    valid_function=_exo31, check_signature=True
)

def _exo32(c):
    l = _exo31(c)
    if l <= 7:
        return "0bbb bbbb"
    if l <= 11:
        return "110b bbbb 10bb bbbb"
    if l <= 16:
        return "1110 bbbb 10bb bbbb 10bb bbbb"
    if l <= 21:
        return "1111 0bbb 10bb bbbb 10bb bbbb 10bb bbbb"
    raise AssertionError("Non défini")
test_exo_3_2 = ValidateFunctionPretty(
    "masque_utf8", ["a", "€","Σ", "😭", "😛"],
    valid_function=_exo32, check_signature=True
)

def _exo41(chaine):
    return chaine[::-1]

test_exo_4_1 = ValidateFunctionPretty(
    "renverse", ["abc", "", "a€Σ😭😛"],
    valid_function=_exo41, check_signature=True
)

def _exo42(masque, c):
    return masque.replace("b", c[0], 1)

test_exo_4_2 = ValidateFunctionPretty(
    "remplace_b_masque", [
        ("000b bbbb", "1"),
        ("000b bbbb", "0"),
        ("000b bbbb", "toto"),
        ("qweqweqweb", "_")
    ], valid_function=_exo42, check_signature=True
)

def _exo43(masque, chaine):
    for c in chaine:
        masque = _exo42(masque, c)
    return masque

test_exo_4_3 = ValidateFunctionPretty(
    "remplir_masque", [
        ("000b bbbb", "111"),
        ("000b bbbb", "1010101010"),
        ("000b bbbb", "azer"),
    ], valid_function=_exo43, check_signature=True
)

def _exo44(masque):
    return masque.replace("b", "0")

test_exo_4_4 = ValidateFunctionPretty(
    "finaliser_masque", ["0001 000b", "bbbb bbbb", "Bob0"],
    valid_function=_exo44, check_signature=True
)

def _exo45(c):
    masque = _exo41(_exo32(c))
    chaine = _exo41(_exo2(c))
    masque = _exo43(masque, chaine)
    return _exo41(_exo44(masque))

test_exo_4_5 = ValidateFunctionPretty(
    "vers_utf8", ["a", "€","Σ", "😭", "😛"],
    valid_function=_exo45, check_signature=True
)
