---
title: Exercices sur l'auto-évaluation
date: Février 2024
author: PCD NSI
prez:
  slidelevel: 2
print: true
fontsize: 12pt
---

# Introduction

En utilisant un des principes suivant :

- Tests avec un IDE
- Tests avec un Notebook
- Notebook séquencé

Créer les tests permettant l’auto-évaluation des exercices ci-dessous, ou bien l’auto-évaluation d'exercices de votre choix.

Les corrections des exercices ci-dessous sont données dans le fichier [autoevaluation.py](https://nuage03.apps.education.fr/index.php/s/9wSQMCYqbtRLFEN)

# Exercices

## Exercice 1 : auto-évaluation de variables 

- Définir la variable ```puissance``` qui vaut $10 \times 5^2$
- Définir les variables suivantes :
    - `ma_chaine` qui vaut `"Résistance"`
    - `intensités` qui vaut `[1, 0.5, 2, 10]`
- Créer un dictionnaire nommé `dressing` permettant de stocker le contenu suivant :

    | vêtement  | quantité |
    |:---------:|:--------:|
    | pantalons |    3     |
    |   pulls   |    4     |
    | tee_shirt |    8     |
- Modifier `dressing` de façon à rajouter 5 chemises.

## Exercice 2 : auto-évaluation de fonctions

- Écrire une fonction appelée `le_plus_grand` qui prend en paramètres deux nombres et qui renvoie le plus grand des deux.
- Écrire une fonction appelée `nb_repetitions` qui prend en paramètres un élément `elt` et une liste `ma_liste` et renvoie le nombre de fois où l’élément apparaît dans la liste.

## Exercice 3 : auto-évaluation en POO {.allowframebreaks}

- On définit une classe `Personne` ayant trois attributs `taille`, `poids` et `age` définissant certaines caractéristiques d’une personne réelle.
- Écrivez le constructeur de cette classe.
- Créez les deux personnes suivantes :
    - Personne 1 : 55 ans, 183cm, 95Kg
    - Personne 2 : 40 ans, 164cm, 67Kg

```{=beamer}
\framebreak
```

- Ajoutez une méthode ```imc()``` permettant de calculer l’IMC d’une personne. 
  Rappel : l’IMC (Indice de Masse Corporelle) est donné par la formule : $$IMC = \frac{poids}{taille^2}$$ avec le poids en kg et la taille en m.
- Ajoutez une méthode ```interpretation()``` qui affiche "Insuffisance pondérale" si l’IMC est inférieur ou égale à 18,5 et "Obésité" si l’IMC est supérieur ou égale à 30.

# Ressources

- [Tests du type ```try...except...else``` avec un notebook ou un IDE](https://codimd.apps.education.fr/S4j0Tsi5SqSvjd5w3zzl1A?view)
- [Auto-évaluation et notebook séquencé](https://capytale.forge.apps.education.fr/basthon/basthon-capytale/parts/sequenced-notebook.html)
- [Visio de présentation du notebook séquencé](https://capytale2.ac-paris.fr/wiki/doku.php?id=notebook_sequence)
- [Verrouiller des cellules dans un notebook](https://capytale2.ac-paris.fr/wiki/doku.php?id=verrouiller_des_cellules)


