import inspect
from contextlib import redirect_stdout
from io import StringIO

def test_exo_1():
    # Test des variables
    g = inspect.stack()[1][0].f_globals
    if "puissance" not in g:
        raise AssertionError("Variable 'puissance' non définie")
    if g["puissance"] != 10 * 0.5**2:
        raise AssertionError("Variable 'puissance' : mauvaise valeur")
    if "ma_chaine" not in g:
        raise AssertionError("Variable 'ma_chaine' non définie")
    if g["ma_chaine"] != "Résistance":
        raise AssertionError("Variable 'ma_chaine' : mauvaise valeur")
    if "intensites" not in g:
        raise AssertionError("Variable 'intensites' non définie")
    if g["intensites"] != [1, 0.5, 2, 10]:
        raise AssertionError("Variable 'intensites' : mauvaise valeur")
    if "dressing" not in g:
        raise AssertionError("Variable 'dressing' non définie")
    if g["dressing"] != {"pantalons": 3, "pulls": 4, "tee-shirts": 8, "chemises": 5}:
        raise AssertionError("Variable 'dressing' : mauvaise valeur")
    
def _pg(a, b):
    return a if a>b else b
def _nr(e,l):
    return len(list(filter(lambda i: i==e, l)))

def test_exo_2():
    g = inspect.stack()[1][0].f_globals
    # Test de la fonction le_plus_grand
    if "le_plus_grand" not in g:
        raise AssertionError("Fonction 'le_plus_grand' non définie")
    pg = g["le_plus_grand"]
    if not callable(pg):
        raise AssertionError("le_plus_grand n'est pas une fonction")
    sig = inspect.signature(pg)
    if len(sig.parameters) != 2:
        raise AssertionError("le_plus_grand doit prendre 2 paramètres")
    if "a" not in sig.parameters:
        raise AssertionError("le_plus_grand doit prendre un paramètre 'a'") 
    if "b" not in sig.parameters:
        raise AssertionError("le_plus_grand doit prendre un paramètre 'b'")
    valeurs_de_test = [(1, 2), (2, 1), (1, 1), (0, 0), (0, 1), (1, 0)]
    for a, b in valeurs_de_test:
        if pg(a, b) != _pg(a, b):
            raise AssertionError(f"le_plus_grand({a}, {b}) : mauvaise valeur")
        
    # Test de la fonction nb_repetitions
    if "nb_repetitions" not in g:
        raise AssertionError("Fonction 'nb_repetitions' non définie")
    nr = g["nb_repetitions"]
    if not callable(nr):
        raise AssertionError("nb_repetitions n'est pas une fonction")
    sig = inspect.signature(nr)
    if len(sig.parameters) != 2:
        raise AssertionError("nb_repetitions doit prendre 2 paramètres")
    if "elt" not in sig.parameters:
        raise AssertionError("nb_repetitions doit prendre un paramètre 'elt'")
    if "ma_liste" not in sig.parameters:
        raise AssertionError("nb_repetitions doit prendre un paramètre 'ma_liste'")
    valeurs_de_test = [(1, [1, 2, 3, 1, 4, 1]), (2, [1, 2, 3, 1, 4, 1]), (1, [2, 3, 4]), (1, [])]   
    for e, l in valeurs_de_test:
        if nr(e, l) != _nr(e, l):
            raise AssertionError(f"nb_repetitions({e}, {l}) : mauvaise valeur")
        
def test_exo_3():
    g = inspect.stack()[1][0].f_globals
    if "Personne" not in g:
        raise AssertionError("Classe 'Personne' non définie")
    if not inspect.isclass(g["Personne"]):
        raise AssertionError("Personne n'est pas une classe")
    per = g["Personne"]
    
    if "__init__" not in per.__dict__:
        raise AssertionError("Personne : pas de méthode __init__")
    isig = inspect.signature(per.__init__)
    if len(isig.parameters) != 4:
        raise AssertionError("Personne.__init__ doit prendre 4 paramètres")
    if "taille" not in isig.parameters:
        raise AssertionError("Personne.__init__ doit prendre un paramètre 'taille'")
    if "poids" not in isig.parameters:
        raise AssertionError("Personne.__init__ doit prendre un paramètre 'poids'")
    if "age" not in isig.parameters:
        raise AssertionError("Personne.__init__ doit prendre un paramètre 'age'")
    
    if "imc" not in per.__dict__:
        raise AssertionError("Personne : pas de méthode imc")
    imsig = inspect.signature(per.imc)
    if len(imsig.parameters) != 1:
        raise AssertionError("Personne.imc doit prendre 1 paramètre")
    if "self" not in imsig.parameters:
        raise AssertionError("Personne.imc doit prendre un paramètre 'self'")
    
    if "interpretation" not in per.__dict__:
        raise AssertionError("Personne : pas de méthode interpretation")
    insig = inspect.signature(per.interpretation)
    if len(insig.parameters) != 1:
        raise AssertionError("Personne.interpretation doit prendre 1 paramètre")
    if "self" not in insig.parameters:
        raise AssertionError("Personne.interpretation doit prendre un paramètre 'self'")
    
   
    p = per(175, 93, 45)
    if abs(p.imc()-30.367346938775512) > 1e8:
        raise AssertionError("Personne(175, 93, 45).imc : mauvaise valeur")
    out = StringIO()
    with redirect_stdout(out):
        p.interpretation()
    if out.getvalue() != "Obésité\n":
        raise AssertionError("Personne(175, 93, 45).interpretation : mauvaise valeur")
    
    p = per(164, 67, 40)
    if abs(p.imc()- 24.910767400356935) > 1e8:
        raise AssertionError("Personne(164, 67, 40).imc : mauvaise valeur")
    out = StringIO()
    with redirect_stdout(out):
        p.interpretation()
    if out.getvalue() != "":
        raise AssertionError("Personne(164, 67, 40).interpretation : mauvaise valeur")

    