# contenu fichier _validation.py
from autoeval import ValidateVariables, ValidateFunction, ValidateFunctionPretty,  ValidateClassContent, ValidateMethod
import random


# Exercice 1 - tests variables
test_variable_puissance = ValidateVariables({'puissance': 2.5})
test_variable_mes_variables = ValidateVariables({'ma_chaine': "Résistance", 'intensites': [1, 0.5, 2, 10]})
test_dressing_1 = ValidateVariables({'dressing': {"pantalons": 3, "pulls": 4, "tee-shirts": 8} })
test_dressing_2 = ValidateVariables({'dressing': {"pantalons": 3, "pulls": 4, "tee-shirts": 8, "chemises": 5} })

test_exo_1 = ValidateVariables({'puissance': 2.5, 'ma_chaine': "Résistance", 'intensites': [1, 0.5, 2, 10], 'dressing': {"pantalons": 3, "pulls": 4, "tee-shirts": 8, "chemises": 5}})

#Exercice 2 - tests fonctions
test_1_le_plus_grand = ValidateFunction(func_name='le_plus_grand',
                                        test_values=((-1,2),(0,0),(5,4)),
                                        target_values=[2,0,5])

test_2_le_plus_grand = ValidateFunctionPretty(func_name='le_plus_grand',
                                              test_values=((-1,2),(0,0),(5,4)),
                                              target_values=[2,0,5])

def _le_plus_grand(a,b):
    if a>b:
        res=a
    else:
        res=b
    return res

valeurs = [(random.randint(-100,100),random.randint(-100,100)) for val in range (10)]

test_3_le_plus_grand = ValidateFunctionPretty(func_name='le_plus_grand',test_values=valeurs,valid_function=_le_plus_grand)

def _nb_repetitions(elt : int ,ma_liste : list)->int:
    oc=0
    for i in ma_liste:
        if elt==i:
            oc+=1
    return oc

valeurs_2=[(j,[random.randint(0,10) for i in range(10)]) for j in range(10)]
test_1_nb_repetitions = ValidateFunctionPretty(func_name='nb_repetitions',
                                               test_values=valeurs_2,
                                               valid_function=_nb_repetitions,
                                               argcount=2)

test_2_nb_repetitions = ValidateFunctionPretty(func_name='nb_repetitions',
                                               test_values=valeurs_2,
                                               valid_function=_nb_repetitions,
                                               argcount=2,
                                               check_signature=True)


# Exercice 3 - tests POO
    
test_personne_1_2 = ValidateClassContent(class_name='Personne', 
                            parameters_init=[(183,95,55),(164,67,40)], 
                            attributs={'taille': [183, 164], 'poids': [95,67], 'age':[55,40]}, 
                            methods = ['imc','interpretation'])

test_imc_interpretation_personne_1 = ValidateMethod(class_name='Personne', 
                               parameters_init=(183,95,55),
                               method_name='imc', 
                               test_values=[()],
                               return_values=[95/1.83**2],
                               method_verif='interpretation',
                               return_values_verif=[None]
                              )